/* service.c generated by valac 0.25.1, the Vala compiler
 * generated from service.vala, do not modify */

/*
 * Copyright(C) 2010 Neil Jagdish Patel
 * Copyright(C) 2010 Canonical Ltd.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * version 3.0 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3.0 for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library. If not, see
 * <http://www.gnu.org/licenses/>.
 *
 * Authored by Neil Jagdish Patel <neil.patel@canonical.com>
 * Authored by Ken VaDine <ken.vandine@canonical.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include "gwibber.h"
#include <json-glib/json-glib.h>


#define TYPE_SERVICE_INTERFACE (service_interface_get_type ())
#define SERVICE_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SERVICE_INTERFACE, ServiceInterface))
#define IS_SERVICE_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SERVICE_INTERFACE))
#define SERVICE_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_SERVICE_INTERFACE, ServiceInterfaceIface))

typedef struct _ServiceInterface ServiceInterface;
typedef struct _ServiceInterfaceIface ServiceInterfaceIface;

#define TYPE_SERVICE_INTERFACE_PROXY (service_interface_proxy_get_type ())
typedef GDBusProxy ServiceInterfaceProxy;
typedef GDBusProxyClass ServiceInterfaceProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))
#define __g_list_free__g_free0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_free0_ (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))

struct _ServiceInterfaceIface {
	GTypeInterface parent_iface;
	void (*Start) (ServiceInterface* self, GError** error);
	void (*Quit) (ServiceInterface* self, GError** error);
	void (*Refresh) (ServiceInterface* self, GError** error);
	void (*SendMessage) (ServiceInterface* self, const gchar* msg, GError** error);
	void (*Send) (ServiceInterface* self, const gchar* msg, GError** error);
	void (*Like) (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error);
	void (*UnLike) (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error);
	void (*Retweet) (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error);
	void (*PerformOp) (ServiceInterface* self, const gchar* op, GError** error);
	void (*UpdateIndicators) (ServiceInterface* self, const gchar* stream, GError** error);
	gchar* (*GetAvatarPath) (ServiceInterface* self, const gchar* url, GError** error);
	gchar* (*GetFeatures) (ServiceInterface* self, GError** error);
	gchar* (*GetServices) (ServiceInterface* self, GError** error);
	gchar* (*GetVersion) (ServiceInterface* self, GError** error);
};

struct _GwibberServicePrivate {
	ServiceInterface* service;
	GHashTable* services_table;
	GHashTable* service_table;
	GHashTable* features_table;
	GHashTable* feature_table;
	GwibberUtils* utils;
	GwibberMessages* messages;
};


static gpointer gwibber_service_parent_class = NULL;

GType service_interface_proxy_get_type (void) G_GNUC_CONST;
guint service_interface_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType service_interface_get_type (void) G_GNUC_CONST;
void service_interface_Start (ServiceInterface* self, GError** error);
void service_interface_Quit (ServiceInterface* self, GError** error);
void service_interface_Refresh (ServiceInterface* self, GError** error);
void service_interface_SendMessage (ServiceInterface* self, const gchar* msg, GError** error);
void service_interface_Send (ServiceInterface* self, const gchar* msg, GError** error);
void service_interface_Like (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error);
void service_interface_UnLike (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error);
void service_interface_Retweet (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error);
void service_interface_PerformOp (ServiceInterface* self, const gchar* op, GError** error);
void service_interface_UpdateIndicators (ServiceInterface* self, const gchar* stream, GError** error);
gchar* service_interface_GetAvatarPath (ServiceInterface* self, const gchar* url, GError** error);
gchar* service_interface_GetFeatures (ServiceInterface* self, GError** error);
gchar* service_interface_GetServices (ServiceInterface* self, GError** error);
gchar* service_interface_GetVersion (ServiceInterface* self, GError** error);
static void service_interface_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters);
static void _dbus_handle_service_interface_loading_started (ServiceInterface* self, GVariant* parameters);
static void _dbus_handle_service_interface_loading_complete (ServiceInterface* self, GVariant* parameters);
static void _dbus_handle_service_interface_error (ServiceInterface* self, GVariant* parameters);
static void service_interface_proxy_Start (ServiceInterface* self, GError** error);
static void service_interface_proxy_Quit (ServiceInterface* self, GError** error);
static void service_interface_proxy_Refresh (ServiceInterface* self, GError** error);
static void service_interface_proxy_SendMessage (ServiceInterface* self, const gchar* msg, GError** error);
static void service_interface_proxy_Send (ServiceInterface* self, const gchar* msg, GError** error);
static void service_interface_proxy_Like (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error);
static void service_interface_proxy_UnLike (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error);
static void service_interface_proxy_Retweet (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error);
static void service_interface_proxy_PerformOp (ServiceInterface* self, const gchar* op, GError** error);
static void service_interface_proxy_UpdateIndicators (ServiceInterface* self, const gchar* stream, GError** error);
static gchar* service_interface_proxy_GetAvatarPath (ServiceInterface* self, const gchar* url, GError** error);
static gchar* service_interface_proxy_GetFeatures (ServiceInterface* self, GError** error);
static gchar* service_interface_proxy_GetServices (ServiceInterface* self, GError** error);
static gchar* service_interface_proxy_GetVersion (ServiceInterface* self, GError** error);
static void service_interface_proxy_service_interface_interface_init (ServiceInterfaceIface* iface);
static void _dbus_service_interface_Start (ServiceInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_Quit (ServiceInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_Refresh (ServiceInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_SendMessage (ServiceInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_Send (ServiceInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_Like (ServiceInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_UnLike (ServiceInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_Retweet (ServiceInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_PerformOp (ServiceInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_UpdateIndicators (ServiceInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_GetAvatarPath (ServiceInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_GetFeatures (ServiceInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_GetServices (ServiceInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_GetVersion (ServiceInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void service_interface_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* service_interface_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static gboolean service_interface_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _dbus_service_interface_loading_started (GObject* _sender, gpointer* _data);
static void _dbus_service_interface_loading_complete (GObject* _sender, gpointer* _data);
static void _dbus_service_interface_error (GObject* _sender, const gchar* error_str, gpointer* _data);
static void _service_interface_unregister_object (gpointer user_data);
#define GWIBBER_SERVICE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GWIBBER_TYPE_SERVICE, GwibberServicePrivate))
enum  {
	GWIBBER_SERVICE_DUMMY_PROPERTY
};
#define GWIBBER_SERVICE_service_name "com.Gwibber.Service"
#define GWIBBER_SERVICE_service_path "/com/gwibber/Service"
static void _vala_JsonNode_free (JsonNode* self);
static void _g_hash_table_remove_all_gdestroy_notify (void* data);
static void _g_free0_ (gpointer var);
static void _g_list_free__g_free0_ (GList* self);
static void _vala_GValue_free (GValue* self);
static GValue* _g_value_dup (GValue* self);
static void g_cclosure_user_marshal_VOID__STRING_STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static GObject * gwibber_service_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
void gwibber_utils_setup (GwibberUtils* self, const gchar* name, GError** error);
static void _gwibber_service_service_available_gwibber_utils_available (GwibberUtils* _sender, gboolean up, gpointer self);
static void _gwibber_service_on_loading_started_service_interface_loading_started (ServiceInterface* _sender, gpointer self);
static void _gwibber_service_on_loading_complete_service_interface_loading_complete (ServiceInterface* _sender, gpointer self);
static void _gwibber_service____lambda8_ (GwibberService* self, const gchar* source);
static void __gwibber_service____lambda8__service_interface_error (ServiceInterface* _sender, const gchar* error_str, gpointer self);
static void gwibber_service_finalize (GObject* obj);

static const GDBusArgInfo * const _service_interface_dbus_arg_info_Start_in[] = {NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Start_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_Start = {-1, "Start", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Start_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Start_out)};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Quit_in[] = {NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Quit_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_Quit = {-1, "Quit", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Quit_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Quit_out)};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Refresh_in[] = {NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Refresh_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_Refresh = {-1, "Refresh", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Refresh_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Refresh_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_SendMessage_msg = {-1, "msg", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_SendMessage_in[] = {&_service_interface_dbus_arg_info_SendMessage_msg, NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_SendMessage_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_SendMessage = {-1, "SendMessage", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_SendMessage_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_SendMessage_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_Send_msg = {-1, "msg", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Send_in[] = {&_service_interface_dbus_arg_info_Send_msg, NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Send_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_Send = {-1, "Send", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Send_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Send_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_Like_mid = {-1, "mid", "s"};
static const GDBusArgInfo _service_interface_dbus_arg_info_Like_account = {-1, "account", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Like_in[] = {&_service_interface_dbus_arg_info_Like_mid, &_service_interface_dbus_arg_info_Like_account, NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Like_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_Like = {-1, "Like", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Like_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Like_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_UnLike_mid = {-1, "mid", "s"};
static const GDBusArgInfo _service_interface_dbus_arg_info_UnLike_account = {-1, "account", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_UnLike_in[] = {&_service_interface_dbus_arg_info_UnLike_mid, &_service_interface_dbus_arg_info_UnLike_account, NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_UnLike_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_UnLike = {-1, "UnLike", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_UnLike_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_UnLike_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_Retweet_mid = {-1, "mid", "s"};
static const GDBusArgInfo _service_interface_dbus_arg_info_Retweet_account = {-1, "account", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Retweet_in[] = {&_service_interface_dbus_arg_info_Retweet_mid, &_service_interface_dbus_arg_info_Retweet_account, NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Retweet_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_Retweet = {-1, "Retweet", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Retweet_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Retweet_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_PerformOp_op = {-1, "op", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_PerformOp_in[] = {&_service_interface_dbus_arg_info_PerformOp_op, NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_PerformOp_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_PerformOp = {-1, "PerformOp", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_PerformOp_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_PerformOp_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_UpdateIndicators_stream = {-1, "stream", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_UpdateIndicators_in[] = {&_service_interface_dbus_arg_info_UpdateIndicators_stream, NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_UpdateIndicators_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_UpdateIndicators = {-1, "UpdateIndicators", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_UpdateIndicators_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_UpdateIndicators_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_GetAvatarPath_url = {-1, "url", "s"};
static const GDBusArgInfo _service_interface_dbus_arg_info_GetAvatarPath_result = {-1, "result", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_GetAvatarPath_in[] = {&_service_interface_dbus_arg_info_GetAvatarPath_url, NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_GetAvatarPath_out[] = {&_service_interface_dbus_arg_info_GetAvatarPath_result, NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_GetAvatarPath = {-1, "GetAvatarPath", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_GetAvatarPath_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_GetAvatarPath_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_GetFeatures_result = {-1, "result", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_GetFeatures_in[] = {NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_GetFeatures_out[] = {&_service_interface_dbus_arg_info_GetFeatures_result, NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_GetFeatures = {-1, "GetFeatures", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_GetFeatures_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_GetFeatures_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_GetServices_result = {-1, "result", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_GetServices_in[] = {NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_GetServices_out[] = {&_service_interface_dbus_arg_info_GetServices_result, NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_GetServices = {-1, "GetServices", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_GetServices_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_GetServices_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_GetVersion_result = {-1, "result", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_GetVersion_in[] = {NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_GetVersion_out[] = {&_service_interface_dbus_arg_info_GetVersion_result, NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_GetVersion = {-1, "GetVersion", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_GetVersion_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_GetVersion_out)};
static const GDBusMethodInfo * const _service_interface_dbus_method_info[] = {&_service_interface_dbus_method_info_Start, &_service_interface_dbus_method_info_Quit, &_service_interface_dbus_method_info_Refresh, &_service_interface_dbus_method_info_SendMessage, &_service_interface_dbus_method_info_Send, &_service_interface_dbus_method_info_Like, &_service_interface_dbus_method_info_UnLike, &_service_interface_dbus_method_info_Retweet, &_service_interface_dbus_method_info_PerformOp, &_service_interface_dbus_method_info_UpdateIndicators, &_service_interface_dbus_method_info_GetAvatarPath, &_service_interface_dbus_method_info_GetFeatures, &_service_interface_dbus_method_info_GetServices, &_service_interface_dbus_method_info_GetVersion, NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_loading_started[] = {NULL};
static const GDBusSignalInfo _service_interface_dbus_signal_info_loading_started = {-1, "LoadingStarted", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_loading_started)};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_loading_complete[] = {NULL};
static const GDBusSignalInfo _service_interface_dbus_signal_info_loading_complete = {-1, "LoadingComplete", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_loading_complete)};
static const GDBusArgInfo _service_interface_dbus_arg_info_error_error_str = {-1, "error_str", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_error[] = {&_service_interface_dbus_arg_info_error_error_str, NULL};
static const GDBusSignalInfo _service_interface_dbus_signal_info_error = {-1, "Error", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_error)};
static const GDBusSignalInfo * const _service_interface_dbus_signal_info[] = {&_service_interface_dbus_signal_info_loading_started, &_service_interface_dbus_signal_info_loading_complete, &_service_interface_dbus_signal_info_error, NULL};
static const GDBusPropertyInfo * const _service_interface_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _service_interface_dbus_interface_info = {-1, "com.Gwibber.Service", (GDBusMethodInfo **) (&_service_interface_dbus_method_info), (GDBusSignalInfo **) (&_service_interface_dbus_signal_info), (GDBusPropertyInfo **) (&_service_interface_dbus_property_info)};
static const GDBusInterfaceVTable _service_interface_dbus_interface_vtable = {service_interface_dbus_interface_method_call, service_interface_dbus_interface_get_property, service_interface_dbus_interface_set_property};

void service_interface_Start (ServiceInterface* self, GError** error) {
	g_return_if_fail (self != NULL);
	SERVICE_INTERFACE_GET_INTERFACE (self)->Start (self, error);
}


void service_interface_Quit (ServiceInterface* self, GError** error) {
	g_return_if_fail (self != NULL);
	SERVICE_INTERFACE_GET_INTERFACE (self)->Quit (self, error);
}


void service_interface_Refresh (ServiceInterface* self, GError** error) {
	g_return_if_fail (self != NULL);
	SERVICE_INTERFACE_GET_INTERFACE (self)->Refresh (self, error);
}


void service_interface_SendMessage (ServiceInterface* self, const gchar* msg, GError** error) {
	g_return_if_fail (self != NULL);
	SERVICE_INTERFACE_GET_INTERFACE (self)->SendMessage (self, msg, error);
}


void service_interface_Send (ServiceInterface* self, const gchar* msg, GError** error) {
	g_return_if_fail (self != NULL);
	SERVICE_INTERFACE_GET_INTERFACE (self)->Send (self, msg, error);
}


void service_interface_Like (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error) {
	g_return_if_fail (self != NULL);
	SERVICE_INTERFACE_GET_INTERFACE (self)->Like (self, mid, account, error);
}


void service_interface_UnLike (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error) {
	g_return_if_fail (self != NULL);
	SERVICE_INTERFACE_GET_INTERFACE (self)->UnLike (self, mid, account, error);
}


void service_interface_Retweet (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error) {
	g_return_if_fail (self != NULL);
	SERVICE_INTERFACE_GET_INTERFACE (self)->Retweet (self, mid, account, error);
}


void service_interface_PerformOp (ServiceInterface* self, const gchar* op, GError** error) {
	g_return_if_fail (self != NULL);
	SERVICE_INTERFACE_GET_INTERFACE (self)->PerformOp (self, op, error);
}


void service_interface_UpdateIndicators (ServiceInterface* self, const gchar* stream, GError** error) {
	g_return_if_fail (self != NULL);
	SERVICE_INTERFACE_GET_INTERFACE (self)->UpdateIndicators (self, stream, error);
}


gchar* service_interface_GetAvatarPath (ServiceInterface* self, const gchar* url, GError** error) {
	g_return_val_if_fail (self != NULL, NULL);
	return SERVICE_INTERFACE_GET_INTERFACE (self)->GetAvatarPath (self, url, error);
}


gchar* service_interface_GetFeatures (ServiceInterface* self, GError** error) {
	g_return_val_if_fail (self != NULL, NULL);
	return SERVICE_INTERFACE_GET_INTERFACE (self)->GetFeatures (self, error);
}


gchar* service_interface_GetServices (ServiceInterface* self, GError** error) {
	g_return_val_if_fail (self != NULL, NULL);
	return SERVICE_INTERFACE_GET_INTERFACE (self)->GetServices (self, error);
}


gchar* service_interface_GetVersion (ServiceInterface* self, GError** error) {
	g_return_val_if_fail (self != NULL, NULL);
	return SERVICE_INTERFACE_GET_INTERFACE (self)->GetVersion (self, error);
}


static void service_interface_base_init (ServiceInterfaceIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		g_signal_new ("loading_started", TYPE_SERVICE_INTERFACE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
		g_signal_new ("loading_complete", TYPE_SERVICE_INTERFACE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
		g_signal_new ("error", TYPE_SERVICE_INTERFACE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	}
}


GType service_interface_get_type (void) {
	static volatile gsize service_interface_type_id__volatile = 0;
	if (g_once_init_enter (&service_interface_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ServiceInterfaceIface), (GBaseInitFunc) service_interface_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType service_interface_type_id;
		service_interface_type_id = g_type_register_static (G_TYPE_INTERFACE, "ServiceInterface", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (service_interface_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (service_interface_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) service_interface_proxy_get_type);
		g_type_set_qdata (service_interface_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "com.Gwibber.Service");
		g_type_set_qdata (service_interface_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) service_interface_register_object);
		g_once_init_leave (&service_interface_type_id__volatile, service_interface_type_id);
	}
	return service_interface_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (ServiceInterfaceProxy, service_interface_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_SERVICE_INTERFACE, service_interface_proxy_service_interface_interface_init) )
static void service_interface_proxy_class_init (ServiceInterfaceProxyClass* klass) {
	G_DBUS_PROXY_CLASS (klass)->g_signal = service_interface_proxy_g_signal;
}


static void _dbus_handle_service_interface_loading_started (ServiceInterface* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "loading-started");
}


static void _dbus_handle_service_interface_loading_complete (ServiceInterface* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "loading-complete");
}


static void _dbus_handle_service_interface_error (ServiceInterface* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	gchar* error_str = NULL;
	GVariant* _tmp8_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp8_ = g_variant_iter_next_value (&_arguments_iter);
	error_str = g_variant_dup_string (_tmp8_, NULL);
	g_variant_unref (_tmp8_);
	g_signal_emit_by_name (self, "error", error_str);
	_g_free0 (error_str);
}


static void service_interface_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters) {
	if (strcmp (signal_name, "LoadingStarted") == 0) {
		_dbus_handle_service_interface_loading_started ((ServiceInterface*) proxy, parameters);
	} else if (strcmp (signal_name, "LoadingComplete") == 0) {
		_dbus_handle_service_interface_loading_complete ((ServiceInterface*) proxy, parameters);
	} else if (strcmp (signal_name, "Error") == 0) {
		_dbus_handle_service_interface_error ((ServiceInterface*) proxy, parameters);
	}
}


static void service_interface_proxy_init (ServiceInterfaceProxy* self) {
}


static void service_interface_proxy_Start (ServiceInterface* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "Start");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void service_interface_proxy_Quit (ServiceInterface* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "Quit");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void service_interface_proxy_Refresh (ServiceInterface* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "Refresh");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void service_interface_proxy_SendMessage (ServiceInterface* self, const gchar* msg, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "SendMessage");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (msg));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void service_interface_proxy_Send (ServiceInterface* self, const gchar* msg, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "Send");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (msg));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void service_interface_proxy_Like (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "Like");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (mid));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (account));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void service_interface_proxy_UnLike (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "UnLike");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (mid));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (account));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void service_interface_proxy_Retweet (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "Retweet");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (mid));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (account));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void service_interface_proxy_PerformOp (ServiceInterface* self, const gchar* op, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "PerformOp");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (op));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void service_interface_proxy_UpdateIndicators (ServiceInterface* self, const gchar* stream, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "UpdateIndicators");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (stream));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static gchar* service_interface_proxy_GetAvatarPath (ServiceInterface* self, const gchar* url, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result;
	GVariant* _tmp9_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "GetAvatarPath");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (url));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp9_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp9_, NULL);
	g_variant_unref (_tmp9_);
	g_object_unref (_reply_message);
	return _result;
}


static gchar* service_interface_proxy_GetFeatures (ServiceInterface* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result;
	GVariant* _tmp10_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "GetFeatures");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp10_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp10_, NULL);
	g_variant_unref (_tmp10_);
	g_object_unref (_reply_message);
	return _result;
}


static gchar* service_interface_proxy_GetServices (ServiceInterface* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result;
	GVariant* _tmp11_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "GetServices");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp11_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp11_, NULL);
	g_variant_unref (_tmp11_);
	g_object_unref (_reply_message);
	return _result;
}


static gchar* service_interface_proxy_GetVersion (ServiceInterface* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result;
	GVariant* _tmp12_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "GetVersion");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp12_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp12_, NULL);
	g_variant_unref (_tmp12_);
	g_object_unref (_reply_message);
	return _result;
}


static void service_interface_proxy_service_interface_interface_init (ServiceInterfaceIface* iface) {
	iface->Start = service_interface_proxy_Start;
	iface->Quit = service_interface_proxy_Quit;
	iface->Refresh = service_interface_proxy_Refresh;
	iface->SendMessage = service_interface_proxy_SendMessage;
	iface->Send = service_interface_proxy_Send;
	iface->Like = service_interface_proxy_Like;
	iface->UnLike = service_interface_proxy_UnLike;
	iface->Retweet = service_interface_proxy_Retweet;
	iface->PerformOp = service_interface_proxy_PerformOp;
	iface->UpdateIndicators = service_interface_proxy_UpdateIndicators;
	iface->GetAvatarPath = service_interface_proxy_GetAvatarPath;
	iface->GetFeatures = service_interface_proxy_GetFeatures;
	iface->GetServices = service_interface_proxy_GetServices;
	iface->GetVersion = service_interface_proxy_GetVersion;
}


static void _dbus_service_interface_Start (ServiceInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	service_interface_Start (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_Quit (ServiceInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	service_interface_Quit (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_Refresh (ServiceInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	service_interface_Refresh (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_SendMessage (ServiceInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* msg = NULL;
	GVariant* _tmp13_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp13_ = g_variant_iter_next_value (&_arguments_iter);
	msg = g_variant_dup_string (_tmp13_, NULL);
	g_variant_unref (_tmp13_);
	service_interface_SendMessage (self, msg, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (msg);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_Send (ServiceInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* msg = NULL;
	GVariant* _tmp14_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp14_ = g_variant_iter_next_value (&_arguments_iter);
	msg = g_variant_dup_string (_tmp14_, NULL);
	g_variant_unref (_tmp14_);
	service_interface_Send (self, msg, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (msg);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_Like (ServiceInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* mid = NULL;
	GVariant* _tmp15_;
	gchar* account = NULL;
	GVariant* _tmp16_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp15_ = g_variant_iter_next_value (&_arguments_iter);
	mid = g_variant_dup_string (_tmp15_, NULL);
	g_variant_unref (_tmp15_);
	_tmp16_ = g_variant_iter_next_value (&_arguments_iter);
	account = g_variant_dup_string (_tmp16_, NULL);
	g_variant_unref (_tmp16_);
	service_interface_Like (self, mid, account, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (mid);
	_g_free0 (account);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_UnLike (ServiceInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* mid = NULL;
	GVariant* _tmp17_;
	gchar* account = NULL;
	GVariant* _tmp18_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp17_ = g_variant_iter_next_value (&_arguments_iter);
	mid = g_variant_dup_string (_tmp17_, NULL);
	g_variant_unref (_tmp17_);
	_tmp18_ = g_variant_iter_next_value (&_arguments_iter);
	account = g_variant_dup_string (_tmp18_, NULL);
	g_variant_unref (_tmp18_);
	service_interface_UnLike (self, mid, account, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (mid);
	_g_free0 (account);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_Retweet (ServiceInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* mid = NULL;
	GVariant* _tmp19_;
	gchar* account = NULL;
	GVariant* _tmp20_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp19_ = g_variant_iter_next_value (&_arguments_iter);
	mid = g_variant_dup_string (_tmp19_, NULL);
	g_variant_unref (_tmp19_);
	_tmp20_ = g_variant_iter_next_value (&_arguments_iter);
	account = g_variant_dup_string (_tmp20_, NULL);
	g_variant_unref (_tmp20_);
	service_interface_Retweet (self, mid, account, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (mid);
	_g_free0 (account);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_PerformOp (ServiceInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* op = NULL;
	GVariant* _tmp21_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp21_ = g_variant_iter_next_value (&_arguments_iter);
	op = g_variant_dup_string (_tmp21_, NULL);
	g_variant_unref (_tmp21_);
	service_interface_PerformOp (self, op, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (op);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_UpdateIndicators (ServiceInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* stream = NULL;
	GVariant* _tmp22_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp22_ = g_variant_iter_next_value (&_arguments_iter);
	stream = g_variant_dup_string (_tmp22_, NULL);
	g_variant_unref (_tmp22_);
	service_interface_UpdateIndicators (self, stream, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (stream);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_GetAvatarPath (ServiceInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* url = NULL;
	GVariant* _tmp23_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp23_ = g_variant_iter_next_value (&_arguments_iter);
	url = g_variant_dup_string (_tmp23_, NULL);
	g_variant_unref (_tmp23_);
	result = service_interface_GetAvatarPath (self, url, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (url);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_GetFeatures (ServiceInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	result = service_interface_GetFeatures (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_GetServices (ServiceInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	result = service_interface_GetServices (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_GetVersion (ServiceInterface* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	result = service_interface_GetVersion (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void service_interface_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Start") == 0) {
		_dbus_service_interface_Start (object, parameters, invocation);
	} else if (strcmp (method_name, "Quit") == 0) {
		_dbus_service_interface_Quit (object, parameters, invocation);
	} else if (strcmp (method_name, "Refresh") == 0) {
		_dbus_service_interface_Refresh (object, parameters, invocation);
	} else if (strcmp (method_name, "SendMessage") == 0) {
		_dbus_service_interface_SendMessage (object, parameters, invocation);
	} else if (strcmp (method_name, "Send") == 0) {
		_dbus_service_interface_Send (object, parameters, invocation);
	} else if (strcmp (method_name, "Like") == 0) {
		_dbus_service_interface_Like (object, parameters, invocation);
	} else if (strcmp (method_name, "UnLike") == 0) {
		_dbus_service_interface_UnLike (object, parameters, invocation);
	} else if (strcmp (method_name, "Retweet") == 0) {
		_dbus_service_interface_Retweet (object, parameters, invocation);
	} else if (strcmp (method_name, "PerformOp") == 0) {
		_dbus_service_interface_PerformOp (object, parameters, invocation);
	} else if (strcmp (method_name, "UpdateIndicators") == 0) {
		_dbus_service_interface_UpdateIndicators (object, parameters, invocation);
	} else if (strcmp (method_name, "GetAvatarPath") == 0) {
		_dbus_service_interface_GetAvatarPath (object, parameters, invocation);
	} else if (strcmp (method_name, "GetFeatures") == 0) {
		_dbus_service_interface_GetFeatures (object, parameters, invocation);
	} else if (strcmp (method_name, "GetServices") == 0) {
		_dbus_service_interface_GetServices (object, parameters, invocation);
	} else if (strcmp (method_name, "GetVersion") == 0) {
		_dbus_service_interface_GetVersion (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* service_interface_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}


static gboolean service_interface_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


static void _dbus_service_interface_loading_started (GObject* _sender, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "com.Gwibber.Service", "LoadingStarted", _arguments, NULL);
}


static void _dbus_service_interface_loading_complete (GObject* _sender, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "com.Gwibber.Service", "LoadingComplete", _arguments, NULL);
}


static void _dbus_service_interface_error (GObject* _sender, const gchar* error_str, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (error_str));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "com.Gwibber.Service", "Error", _arguments, NULL);
}


guint service_interface_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_service_interface_dbus_interface_info), &_service_interface_dbus_interface_vtable, data, _service_interface_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "loading-started", (GCallback) _dbus_service_interface_loading_started, data);
	g_signal_connect (object, "loading-complete", (GCallback) _dbus_service_interface_loading_complete, data);
	g_signal_connect (object, "error", (GCallback) _dbus_service_interface_error, data);
	return result;
}


static void _service_interface_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_service_interface_loading_started, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_service_interface_loading_complete, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_service_interface_error, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


void gwibber_service_service_available (GwibberService* self, gboolean is_up) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = is_up;
	g_signal_emit_by_name (self, "is-available", _tmp0_);
}


void gwibber_service_on_loading_started (GwibberService* self) {
	g_return_if_fail (self != NULL);
	g_signal_emit_by_name (self, "loading-started");
}


void gwibber_service_on_loading_complete (GwibberService* self) {
	g_return_if_fail (self != NULL);
	g_signal_emit_by_name (self, "loading-complete");
}


static gpointer _json_object_ref0 (gpointer self) {
	return self ? json_object_ref (self) : NULL;
}


void gwibber_service_on_error (GwibberService* self, const gchar* error_str) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (error_str != NULL);
	{
		JsonParser* parser = NULL;
		JsonParser* _tmp0_ = NULL;
		const gchar* _tmp1_ = NULL;
		JsonObject* root_object = NULL;
		JsonNode* _tmp2_ = NULL;
		JsonObject* _tmp3_ = NULL;
		JsonObject* _tmp4_ = NULL;
		JsonObject* error_object = NULL;
		JsonObject* _tmp5_ = NULL;
		JsonNode* _tmp6_ = NULL;
		JsonObject* _tmp7_ = NULL;
		JsonObject* _tmp8_ = NULL;
		JsonObject* account_object = NULL;
		JsonObject* _tmp9_ = NULL;
		JsonNode* _tmp10_ = NULL;
		JsonObject* _tmp11_ = NULL;
		JsonObject* _tmp12_ = NULL;
		gchar* id = NULL;
		JsonObject* _tmp13_ = NULL;
		JsonNode* _tmp14_ = NULL;
		const gchar* _tmp15_ = NULL;
		gchar* _tmp16_ = NULL;
		gchar* type = NULL;
		JsonObject* _tmp17_ = NULL;
		JsonNode* _tmp18_ = NULL;
		const gchar* _tmp19_ = NULL;
		gchar* _tmp20_ = NULL;
		gchar* message = NULL;
		JsonObject* _tmp21_ = NULL;
		JsonNode* _tmp22_ = NULL;
		const gchar* _tmp23_ = NULL;
		gchar* _tmp24_ = NULL;
		const gchar* _tmp25_ = NULL;
		const gchar* _tmp26_ = NULL;
		const gchar* _tmp27_ = NULL;
		_tmp0_ = json_parser_new ();
		parser = _tmp0_;
		_tmp1_ = error_str;
		json_parser_load_from_data (parser, _tmp1_, (gssize) (-1), &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (parser);
			goto __catch11_g_error;
		}
		_tmp2_ = json_parser_get_root (parser);
		_tmp3_ = json_node_get_object (_tmp2_);
		_tmp4_ = _json_object_ref0 (_tmp3_);
		root_object = _tmp4_;
		_tmp5_ = root_object;
		_tmp6_ = json_object_get_member (_tmp5_, "error");
		_tmp7_ = json_node_get_object (_tmp6_);
		_tmp8_ = _json_object_ref0 (_tmp7_);
		error_object = _tmp8_;
		_tmp9_ = error_object;
		_tmp10_ = json_object_get_member (_tmp9_, "account");
		_tmp11_ = json_node_get_object (_tmp10_);
		_tmp12_ = _json_object_ref0 (_tmp11_);
		account_object = _tmp12_;
		_tmp13_ = account_object;
		_tmp14_ = json_object_get_member (_tmp13_, "id");
		_tmp15_ = json_node_get_string (_tmp14_);
		_tmp16_ = g_strdup (_tmp15_);
		id = _tmp16_;
		_tmp17_ = error_object;
		_tmp18_ = json_object_get_member (_tmp17_, "type");
		_tmp19_ = json_node_get_string (_tmp18_);
		_tmp20_ = g_strdup (_tmp19_);
		type = _tmp20_;
		_tmp21_ = error_object;
		_tmp22_ = json_object_get_member (_tmp21_, "message");
		_tmp23_ = json_node_get_string (_tmp22_);
		_tmp24_ = g_strdup (_tmp23_);
		message = _tmp24_;
		_tmp25_ = id;
		_tmp26_ = type;
		_tmp27_ = message;
		g_signal_emit_by_name (self, "error", _tmp25_, _tmp26_, _tmp27_);
		_g_free0 (message);
		_g_free0 (type);
		_g_free0 (id);
		_json_object_unref0 (account_object);
		_json_object_unref0 (error_object);
		_json_object_unref0 (root_object);
		_g_object_unref0 (parser);
	}
	goto __finally11;
	__catch11_g_error:
	{
		GError* e = NULL;
		GError* _tmp28_ = NULL;
		const gchar* _tmp29_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp28_ = e;
		_tmp29_ = _tmp28_->message;
		g_warning ("service.vala:146: %s", _tmp29_);
		_g_error_free0 (e);
	}
	__finally11:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


/**
            start:
        */
void gwibber_service_start (GwibberService* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		ServiceInterface* _tmp0_ = NULL;
		_tmp0_ = self->priv->service;
		service_interface_Start (_tmp0_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch12_g_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	goto __finally12;
	__catch12_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp1_ = e;
		_tmp2_ = _tmp1_->message;
		g_warning ("service.vala:158: %s", _tmp2_);
		_g_error_free0 (e);
	}
	__finally12:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


/**
            quit:

            Tells the gwibber service to shutdown.
        */
void gwibber_service_quit (GwibberService* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		ServiceInterface* _tmp0_ = NULL;
		_tmp0_ = self->priv->service;
		service_interface_Quit (_tmp0_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch13_g_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	goto __finally13;
	__catch13_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp1_ = e;
		_tmp2_ = _tmp1_->message;
		g_warning ("service.vala:172: %s", _tmp2_);
		_g_error_free0 (e);
	}
	__finally13:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


/**
            refresh:

            Tells the gwibber service to perform a refresh.
        */
void gwibber_service_refresh (GwibberService* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		ServiceInterface* _tmp0_ = NULL;
		_tmp0_ = self->priv->service;
		service_interface_Refresh (_tmp0_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch14_g_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	goto __finally14;
	__catch14_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp1_ = e;
		_tmp2_ = _tmp1_->message;
		g_warning ("service.vala:186: %s", _tmp2_);
		_g_error_free0 (e);
	}
	__finally14:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


/**
            like:
            @id: the gwibber message id
            @account: the account id
           
            returns a bool
        */
gboolean gwibber_service_like (GwibberService* self, const gchar* id, const gchar* account) {
	gboolean result = FALSE;
	gchar* mid = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (id != NULL, FALSE);
	g_return_val_if_fail (account != NULL, FALSE);
	_tmp0_ = g_strdup ("");
	mid = _tmp0_;
	_tmp1_ = id;
	if (_tmp1_ != NULL) {
		{
			gchar* msg = NULL;
			GwibberMessages* _tmp2_ = NULL;
			const gchar* _tmp3_ = NULL;
			gchar* _tmp4_ = NULL;
			const gchar* _tmp5_ = NULL;
			gint _tmp6_ = 0;
			gint _tmp7_ = 0;
			JsonParser* parser = NULL;
			JsonParser* _tmp8_ = NULL;
			JsonParser* _tmp9_ = NULL;
			const gchar* _tmp10_ = NULL;
			JsonParser* _tmp11_ = NULL;
			JsonNode* _tmp12_ = NULL;
			JsonObject* _tmp13_ = NULL;
			const gchar* _tmp14_ = NULL;
			gchar* _tmp15_ = NULL;
			const gchar* _tmp16_ = NULL;
			gint _tmp17_ = 0;
			gint _tmp18_ = 0;
			_tmp2_ = self->priv->messages;
			_tmp3_ = id;
			_tmp4_ = gwibber_messages_get_message (_tmp2_, _tmp3_);
			msg = _tmp4_;
			_tmp5_ = msg;
			_tmp6_ = strlen (_tmp5_);
			_tmp7_ = _tmp6_;
			if (_tmp7_ < 1) {
				result = FALSE;
				_g_free0 (msg);
				_g_free0 (mid);
				return result;
			}
			_tmp8_ = json_parser_new ();
			parser = _tmp8_;
			_tmp9_ = parser;
			_tmp10_ = msg;
			json_parser_load_from_data (_tmp9_, _tmp10_, (gssize) (-1), &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (parser);
				_g_free0 (msg);
				goto __catch15_g_error;
			}
			_tmp11_ = parser;
			_tmp12_ = json_parser_get_root (_tmp11_);
			_tmp13_ = json_node_get_object (_tmp12_);
			_tmp14_ = json_object_get_string_member (_tmp13_, "mid");
			_tmp15_ = g_strdup (_tmp14_);
			_g_free0 (mid);
			mid = _tmp15_;
			_tmp16_ = mid;
			_tmp17_ = strlen (_tmp16_);
			_tmp18_ = _tmp17_;
			if (_tmp18_ < 1) {
				result = FALSE;
				_g_object_unref0 (parser);
				_g_free0 (msg);
				_g_free0 (mid);
				return result;
			}
			{
				ServiceInterface* _tmp19_ = NULL;
				const gchar* _tmp20_ = NULL;
				const gchar* _tmp21_ = NULL;
				_tmp19_ = self->priv->service;
				_tmp20_ = mid;
				_tmp21_ = account;
				service_interface_Like (_tmp19_, _tmp20_, _tmp21_, &_inner_error_);
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					if (_inner_error_->domain == G_IO_ERROR) {
						goto __catch16_g_io_error;
					}
					_g_object_unref0 (parser);
					_g_free0 (msg);
					_g_free0 (mid);
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return FALSE;
				}
				result = TRUE;
				_g_object_unref0 (parser);
				_g_free0 (msg);
				_g_free0 (mid);
				return result;
			}
			goto __finally16;
			__catch16_g_io_error:
			{
				GError* e = NULL;
				GError* _tmp22_ = NULL;
				const gchar* _tmp23_ = NULL;
				e = _inner_error_;
				_inner_error_ = NULL;
				_tmp22_ = e;
				_tmp23_ = _tmp22_->message;
				g_warning ("service.vala:217: %s", _tmp23_);
				result = FALSE;
				_g_error_free0 (e);
				_g_object_unref0 (parser);
				_g_free0 (msg);
				_g_free0 (mid);
				return result;
			}
			__finally16:
			_g_object_unref0 (parser);
			_g_free0 (msg);
			goto __catch15_g_error;
		}
		goto __finally15;
		__catch15_g_error:
		{
			GError* e = NULL;
			GError* _tmp24_ = NULL;
			const gchar* _tmp25_ = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp24_ = e;
			_tmp25_ = _tmp24_->message;
			g_warning ("service.vala:221: %s", _tmp25_);
			result = FALSE;
			_g_error_free0 (e);
			_g_free0 (mid);
			return result;
		}
		__finally15:
		_g_free0 (mid);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	result = FALSE;
	_g_free0 (mid);
	return result;
}


/**
            unlike:
            @id: the gwibber message id
            @account: the account id
           
            returns a bool
        */
gboolean gwibber_service_unlike (GwibberService* self, const gchar* id, const gchar* account) {
	gboolean result = FALSE;
	gchar* mid = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (id != NULL, FALSE);
	g_return_val_if_fail (account != NULL, FALSE);
	_tmp0_ = g_strdup ("");
	mid = _tmp0_;
	_tmp1_ = id;
	if (_tmp1_ != NULL) {
		{
			gchar* msg = NULL;
			GwibberMessages* _tmp2_ = NULL;
			const gchar* _tmp3_ = NULL;
			gchar* _tmp4_ = NULL;
			const gchar* _tmp5_ = NULL;
			gint _tmp6_ = 0;
			gint _tmp7_ = 0;
			JsonParser* parser = NULL;
			JsonParser* _tmp8_ = NULL;
			JsonParser* _tmp9_ = NULL;
			const gchar* _tmp10_ = NULL;
			JsonParser* _tmp11_ = NULL;
			JsonNode* _tmp12_ = NULL;
			JsonObject* _tmp13_ = NULL;
			const gchar* _tmp14_ = NULL;
			gchar* _tmp15_ = NULL;
			const gchar* _tmp16_ = NULL;
			gint _tmp17_ = 0;
			gint _tmp18_ = 0;
			_tmp2_ = self->priv->messages;
			_tmp3_ = id;
			_tmp4_ = gwibber_messages_get_message (_tmp2_, _tmp3_);
			msg = _tmp4_;
			_tmp5_ = msg;
			_tmp6_ = strlen (_tmp5_);
			_tmp7_ = _tmp6_;
			if (_tmp7_ < 1) {
				result = FALSE;
				_g_free0 (msg);
				_g_free0 (mid);
				return result;
			}
			_tmp8_ = json_parser_new ();
			parser = _tmp8_;
			_tmp9_ = parser;
			_tmp10_ = msg;
			json_parser_load_from_data (_tmp9_, _tmp10_, (gssize) (-1), &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (parser);
				_g_free0 (msg);
				goto __catch17_g_error;
			}
			_tmp11_ = parser;
			_tmp12_ = json_parser_get_root (_tmp11_);
			_tmp13_ = json_node_get_object (_tmp12_);
			_tmp14_ = json_object_get_string_member (_tmp13_, "mid");
			_tmp15_ = g_strdup (_tmp14_);
			_g_free0 (mid);
			mid = _tmp15_;
			_tmp16_ = mid;
			_tmp17_ = strlen (_tmp16_);
			_tmp18_ = _tmp17_;
			if (_tmp18_ < 1) {
				result = FALSE;
				_g_object_unref0 (parser);
				_g_free0 (msg);
				_g_free0 (mid);
				return result;
			}
			{
				ServiceInterface* _tmp19_ = NULL;
				const gchar* _tmp20_ = NULL;
				const gchar* _tmp21_ = NULL;
				_tmp19_ = self->priv->service;
				_tmp20_ = mid;
				_tmp21_ = account;
				service_interface_UnLike (_tmp19_, _tmp20_, _tmp21_, &_inner_error_);
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					if (_inner_error_->domain == G_IO_ERROR) {
						goto __catch18_g_io_error;
					}
					_g_object_unref0 (parser);
					_g_free0 (msg);
					_g_free0 (mid);
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return FALSE;
				}
				result = TRUE;
				_g_object_unref0 (parser);
				_g_free0 (msg);
				_g_free0 (mid);
				return result;
			}
			goto __finally18;
			__catch18_g_io_error:
			{
				GError* e = NULL;
				GError* _tmp22_ = NULL;
				const gchar* _tmp23_ = NULL;
				e = _inner_error_;
				_inner_error_ = NULL;
				_tmp22_ = e;
				_tmp23_ = _tmp22_->message;
				g_warning ("service.vala:255: %s", _tmp23_);
				result = FALSE;
				_g_error_free0 (e);
				_g_object_unref0 (parser);
				_g_free0 (msg);
				_g_free0 (mid);
				return result;
			}
			__finally18:
			_g_object_unref0 (parser);
			_g_free0 (msg);
			goto __catch17_g_error;
		}
		goto __finally17;
		__catch17_g_error:
		{
			GError* e = NULL;
			GError* _tmp24_ = NULL;
			const gchar* _tmp25_ = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp24_ = e;
			_tmp25_ = _tmp24_->message;
			g_warning ("service.vala:259: %s", _tmp25_);
			result = FALSE;
			_g_error_free0 (e);
			_g_free0 (mid);
			return result;
		}
		__finally17:
		_g_free0 (mid);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	result = FALSE;
	_g_free0 (mid);
	return result;
}


/**
            retweet:
            @id: the gwibber message id
            @account: the account id
           
            returns a bool
        */
gboolean gwibber_service_retweet (GwibberService* self, const gchar* id, const gchar* account) {
	gboolean result = FALSE;
	gchar* mid = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (id != NULL, FALSE);
	g_return_val_if_fail (account != NULL, FALSE);
	_tmp0_ = g_strdup ("");
	mid = _tmp0_;
	_tmp1_ = id;
	if (_tmp1_ != NULL) {
		{
			gchar* msg = NULL;
			GwibberMessages* _tmp2_ = NULL;
			const gchar* _tmp3_ = NULL;
			gchar* _tmp4_ = NULL;
			const gchar* _tmp5_ = NULL;
			gint _tmp6_ = 0;
			gint _tmp7_ = 0;
			JsonParser* parser = NULL;
			JsonParser* _tmp8_ = NULL;
			JsonParser* _tmp9_ = NULL;
			const gchar* _tmp10_ = NULL;
			JsonParser* _tmp11_ = NULL;
			JsonNode* _tmp12_ = NULL;
			JsonObject* _tmp13_ = NULL;
			const gchar* _tmp14_ = NULL;
			gchar* _tmp15_ = NULL;
			const gchar* _tmp16_ = NULL;
			gint _tmp17_ = 0;
			gint _tmp18_ = 0;
			_tmp2_ = self->priv->messages;
			_tmp3_ = id;
			_tmp4_ = gwibber_messages_get_message (_tmp2_, _tmp3_);
			msg = _tmp4_;
			_tmp5_ = msg;
			_tmp6_ = strlen (_tmp5_);
			_tmp7_ = _tmp6_;
			if (_tmp7_ < 1) {
				result = FALSE;
				_g_free0 (msg);
				_g_free0 (mid);
				return result;
			}
			_tmp8_ = json_parser_new ();
			parser = _tmp8_;
			_tmp9_ = parser;
			_tmp10_ = msg;
			json_parser_load_from_data (_tmp9_, _tmp10_, (gssize) (-1), &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (parser);
				_g_free0 (msg);
				goto __catch19_g_error;
			}
			_tmp11_ = parser;
			_tmp12_ = json_parser_get_root (_tmp11_);
			_tmp13_ = json_node_get_object (_tmp12_);
			_tmp14_ = json_object_get_string_member (_tmp13_, "mid");
			_tmp15_ = g_strdup (_tmp14_);
			_g_free0 (mid);
			mid = _tmp15_;
			_tmp16_ = mid;
			_tmp17_ = strlen (_tmp16_);
			_tmp18_ = _tmp17_;
			if (_tmp18_ < 1) {
				result = FALSE;
				_g_object_unref0 (parser);
				_g_free0 (msg);
				_g_free0 (mid);
				return result;
			}
			{
				ServiceInterface* _tmp19_ = NULL;
				const gchar* _tmp20_ = NULL;
				const gchar* _tmp21_ = NULL;
				_tmp19_ = self->priv->service;
				_tmp20_ = mid;
				_tmp21_ = account;
				service_interface_Retweet (_tmp19_, _tmp20_, _tmp21_, &_inner_error_);
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					if (_inner_error_->domain == G_IO_ERROR) {
						goto __catch20_g_io_error;
					}
					_g_object_unref0 (parser);
					_g_free0 (msg);
					_g_free0 (mid);
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return FALSE;
				}
				result = TRUE;
				_g_object_unref0 (parser);
				_g_free0 (msg);
				_g_free0 (mid);
				return result;
			}
			goto __finally20;
			__catch20_g_io_error:
			{
				GError* e = NULL;
				GError* _tmp22_ = NULL;
				const gchar* _tmp23_ = NULL;
				e = _inner_error_;
				_inner_error_ = NULL;
				_tmp22_ = e;
				_tmp23_ = _tmp22_->message;
				g_warning ("service.vala:296: %s", _tmp23_);
				result = FALSE;
				_g_error_free0 (e);
				_g_object_unref0 (parser);
				_g_free0 (msg);
				_g_free0 (mid);
				return result;
			}
			__finally20:
			_g_object_unref0 (parser);
			_g_free0 (msg);
			goto __catch19_g_error;
		}
		goto __finally19;
		__catch19_g_error:
		{
			GError* e = NULL;
			GError* _tmp24_ = NULL;
			const gchar* _tmp25_ = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp24_ = e;
			_tmp25_ = _tmp24_->message;
			g_warning ("service.vala:300: %s", _tmp25_);
			result = FALSE;
			_g_error_free0 (e);
			_g_free0 (mid);
			return result;
		}
		__finally19:
		_g_free0 (mid);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	result = FALSE;
	_g_free0 (mid);
	return result;
}


/**
            send_message:
            @message: The message to post to Gwibber
            @id: The gwibber message id or null
            @action: The action or null
            @account: The account to post from  or null

            Posts a message
        */
static void _vala_JsonNode_free (JsonNode* self) {
	g_boxed_free (json_node_get_type (), self);
}


static gpointer _json_array_ref0 (gpointer self) {
	return self ? json_array_ref (self) : NULL;
}


gboolean gwibber_service_send_message (GwibberService* self, const gchar* message, const gchar* id, const gchar* action, gchar** accounts, int accounts_length1) {
	gboolean result = FALSE;
	gsize length = 0UL;
	gchar* json = NULL;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = id;
	if (_tmp1_ != NULL) {
		const gchar* _tmp2_ = NULL;
		_tmp2_ = action;
		_tmp0_ = _tmp2_ != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		{
			gchar* msg = NULL;
			GwibberMessages* _tmp3_ = NULL;
			const gchar* _tmp4_ = NULL;
			gchar* _tmp5_ = NULL;
			const gchar* _tmp6_ = NULL;
			gint _tmp7_ = 0;
			gint _tmp8_ = 0;
			JsonGenerator* msg_gen = NULL;
			JsonGenerator* _tmp9_ = NULL;
			JsonNode* root = NULL;
			JsonNode* _tmp10_ = NULL;
			JsonObject* object = NULL;
			JsonObject* _tmp11_ = NULL;
			JsonNode* _tmp12_ = NULL;
			JsonObject* _tmp13_ = NULL;
			JsonGenerator* _tmp14_ = NULL;
			JsonNode* _tmp15_ = NULL;
			JsonParser* parser = NULL;
			JsonParser* _tmp16_ = NULL;
			JsonParser* _tmp17_ = NULL;
			const gchar* _tmp18_ = NULL;
			JsonObject* _tmp19_ = NULL;
			const gchar* _tmp20_ = NULL;
			const gchar* _tmp21_ = NULL;
			const gchar* _tmp27_ = NULL;
			JsonObject* _tmp33_ = NULL;
			const gchar* _tmp34_ = NULL;
			gchar** _tmp35_ = NULL;
			gint _tmp35__length1 = 0;
			JsonGenerator* _tmp44_ = NULL;
			gsize _tmp45_ = 0UL;
			gchar* _tmp46_ = NULL;
			ServiceInterface* _tmp47_ = NULL;
			const gchar* _tmp48_ = NULL;
			_tmp3_ = self->priv->messages;
			_tmp4_ = id;
			_tmp5_ = gwibber_messages_get_message (_tmp3_, _tmp4_);
			msg = _tmp5_;
			_tmp6_ = msg;
			_tmp7_ = strlen (_tmp6_);
			_tmp8_ = _tmp7_;
			if (_tmp8_ < 1) {
				result = FALSE;
				_g_free0 (msg);
				_g_free0 (json);
				return result;
			}
			_tmp9_ = json_generator_new ();
			msg_gen = _tmp9_;
			_tmp10_ = json_node_new (JSON_NODE_OBJECT);
			root = _tmp10_;
			_tmp11_ = json_object_new ();
			object = _tmp11_;
			_tmp12_ = root;
			_tmp13_ = object;
			json_node_set_object (_tmp12_, _tmp13_);
			_tmp14_ = msg_gen;
			_tmp15_ = root;
			json_generator_set_root (_tmp14_, _tmp15_);
			_tmp16_ = json_parser_new ();
			parser = _tmp16_;
			_tmp17_ = parser;
			_tmp18_ = msg;
			json_parser_load_from_data (_tmp17_, _tmp18_, (gssize) (-1), &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (parser);
				_json_object_unref0 (object);
				__vala_JsonNode_free0 (root);
				_g_object_unref0 (msg_gen);
				_g_free0 (msg);
				goto __catch21_g_error;
			}
			_tmp19_ = object;
			_tmp20_ = message;
			json_object_set_string_member (_tmp19_, "message", _tmp20_);
			_tmp21_ = action;
			if (g_strcmp0 (_tmp21_, "reply") == 0) {
				JsonObject* _tmp22_ = NULL;
				JsonParser* _tmp23_ = NULL;
				JsonNode* _tmp24_ = NULL;
				JsonObject* _tmp25_ = NULL;
				JsonObject* _tmp26_ = NULL;
				_tmp22_ = object;
				_tmp23_ = parser;
				_tmp24_ = json_parser_get_root (_tmp23_);
				_tmp25_ = json_node_get_object (_tmp24_);
				_tmp26_ = _json_object_ref0 (_tmp25_);
				json_object_set_object_member (_tmp22_, "target", _tmp26_);
			}
			_tmp27_ = action;
			if (g_strcmp0 (_tmp27_, "private") == 0) {
				JsonObject* _tmp28_ = NULL;
				JsonParser* _tmp29_ = NULL;
				JsonNode* _tmp30_ = NULL;
				JsonObject* _tmp31_ = NULL;
				JsonObject* _tmp32_ = NULL;
				_tmp28_ = object;
				_tmp29_ = parser;
				_tmp30_ = json_parser_get_root (_tmp29_);
				_tmp31_ = json_node_get_object (_tmp30_);
				_tmp32_ = _json_object_ref0 (_tmp31_);
				json_object_set_object_member (_tmp28_, "private", _tmp32_);
			}
			_tmp33_ = object;
			_tmp34_ = action;
			json_object_set_string_member (_tmp33_, "action", _tmp34_);
			_tmp35_ = accounts;
			_tmp35__length1 = accounts_length1;
			if (_tmp35__length1 > 0) {
				JsonArray* acct_array = NULL;
				JsonArray* _tmp36_ = NULL;
				gchar** _tmp37_ = NULL;
				gint _tmp37__length1 = 0;
				JsonObject* _tmp41_ = NULL;
				JsonArray* _tmp42_ = NULL;
				JsonArray* _tmp43_ = NULL;
				_tmp36_ = json_array_new ();
				acct_array = _tmp36_;
				_tmp37_ = accounts;
				_tmp37__length1 = accounts_length1;
				{
					gchar** a_collection = NULL;
					gint a_collection_length1 = 0;
					gint _a_collection_size_ = 0;
					gint a_it = 0;
					a_collection = _tmp37_;
					a_collection_length1 = _tmp37__length1;
					for (a_it = 0; a_it < _tmp37__length1; a_it = a_it + 1) {
						gchar* _tmp38_ = NULL;
						gchar* a = NULL;
						_tmp38_ = g_strdup (a_collection[a_it]);
						a = _tmp38_;
						{
							JsonArray* _tmp39_ = NULL;
							const gchar* _tmp40_ = NULL;
							_tmp39_ = acct_array;
							_tmp40_ = a;
							json_array_add_string_element (_tmp39_, _tmp40_);
							_g_free0 (a);
						}
					}
				}
				_tmp41_ = object;
				_tmp42_ = acct_array;
				_tmp43_ = _json_array_ref0 (_tmp42_);
				json_object_set_array_member (_tmp41_, "accounts", _tmp43_);
				_json_array_unref0 (acct_array);
			}
			_tmp44_ = msg_gen;
			_tmp46_ = json_generator_to_data (_tmp44_, &_tmp45_);
			length = _tmp45_;
			_g_free0 (json);
			json = _tmp46_;
			_tmp47_ = self->priv->service;
			_tmp48_ = json;
			service_interface_Send (_tmp47_, (const gchar*) _tmp48_, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (parser);
				_json_object_unref0 (object);
				__vala_JsonNode_free0 (root);
				_g_object_unref0 (msg_gen);
				_g_free0 (msg);
				goto __catch21_g_error;
			}
			result = TRUE;
			_g_object_unref0 (parser);
			_json_object_unref0 (object);
			__vala_JsonNode_free0 (root);
			_g_object_unref0 (msg_gen);
			_g_free0 (msg);
			_g_free0 (json);
			return result;
		}
		goto __finally21;
		__catch21_g_error:
		{
			GError* e = NULL;
			GError* _tmp49_ = NULL;
			const gchar* _tmp50_ = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp49_ = e;
			_tmp50_ = _tmp49_->message;
			g_warning ("service.vala:356: %s", _tmp50_);
			result = FALSE;
			_g_error_free0 (e);
			_g_free0 (json);
			return result;
		}
		__finally21:
		_g_free0 (json);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	} else {
		{
			ServiceInterface* _tmp51_ = NULL;
			const gchar* _tmp52_ = NULL;
			_tmp51_ = self->priv->service;
			_tmp52_ = message;
			service_interface_SendMessage (_tmp51_, _tmp52_, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				if (_inner_error_->domain == G_IO_ERROR) {
					goto __catch22_g_io_error;
				}
				_g_free0 (json);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return FALSE;
			}
			result = TRUE;
			_g_free0 (json);
			return result;
		}
		goto __finally22;
		__catch22_g_io_error:
		{
			GError* e = NULL;
			GError* _tmp53_ = NULL;
			const gchar* _tmp54_ = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp53_ = e;
			_tmp54_ = _tmp53_->message;
			g_warning ("service.vala:365: %s", _tmp54_);
			result = FALSE;
			_g_error_free0 (e);
			_g_free0 (json);
			return result;
		}
		__finally22:
		_g_free0 (json);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	_g_free0 (json);
}


static void _g_hash_table_remove_all_gdestroy_notify (void* data) {
	g_hash_table_remove_all (data);
}


static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static void _g_list_free__g_free0_ (GList* self) {
	g_list_foreach (self, (GFunc) _g_free0_, NULL);
	g_list_free (self);
}


static gpointer _g_hash_table_ref0 (gpointer self) {
	return self ? g_hash_table_ref (self) : NULL;
}


GHashTable* gwibber_service_services (GwibberService* self) {
	GHashTable* result = NULL;
	GHashFunc _tmp0_ = NULL;
	GEqualFunc _tmp1_ = NULL;
	GDestroyNotify _tmp2_ = NULL;
	GHashTable* _tmp3_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_str_hash;
	_tmp1_ = g_str_equal;
	_tmp2_ = g_free;
	_tmp3_ = g_hash_table_new_full (_tmp0_, _tmp1_, _tmp2_, _g_hash_table_remove_all_gdestroy_notify);
	_g_hash_table_unref0 (self->priv->services_table);
	self->priv->services_table = _tmp3_;
	{
		gchar* services = NULL;
		ServiceInterface* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		JsonParser* parser = NULL;
		JsonParser* _tmp6_ = NULL;
		JsonObject* root_object = NULL;
		JsonParser* _tmp11_ = NULL;
		JsonNode* _tmp12_ = NULL;
		JsonObject* _tmp13_ = NULL;
		JsonObject* _tmp14_ = NULL;
		JsonObject* _tmp15_ = NULL;
		GList* _tmp16_ = NULL;
		GHashTable* _tmp59_ = NULL;
		GHashTable* _tmp60_ = NULL;
		_tmp4_ = self->priv->service;
		_tmp5_ = service_interface_GetServices (_tmp4_, &_inner_error_);
		services = _tmp5_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch23_g_error;
		}
		_tmp6_ = json_parser_new ();
		parser = _tmp6_;
		{
			JsonParser* _tmp7_ = NULL;
			const gchar* _tmp8_ = NULL;
			_tmp7_ = parser;
			_tmp8_ = services;
			json_parser_load_from_data (_tmp7_, _tmp8_, (gssize) (-1), &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch24_g_error;
			}
		}
		goto __finally24;
		__catch24_g_error:
		{
			GError* e = NULL;
			GError* _tmp9_ = NULL;
			const gchar* _tmp10_ = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp9_ = e;
			_tmp10_ = _tmp9_->message;
			g_warning ("service.vala:381: %s", _tmp10_);
			result = NULL;
			_g_error_free0 (e);
			_g_object_unref0 (parser);
			_g_free0 (services);
			return result;
		}
		__finally24:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (parser);
			_g_free0 (services);
			goto __catch23_g_error;
		}
		_tmp11_ = parser;
		_tmp12_ = json_parser_get_root (_tmp11_);
		_tmp13_ = json_node_get_object (_tmp12_);
		_tmp14_ = _json_object_ref0 (_tmp13_);
		root_object = _tmp14_;
		_tmp15_ = root_object;
		_tmp16_ = json_object_get_members (_tmp15_);
		{
			GList* service_collection = NULL;
			GList* service_it = NULL;
			service_collection = _tmp16_;
			for (service_it = service_collection; service_it != NULL; service_it = service_it->next) {
				const gchar* service = NULL;
				service = (const gchar*) service_it->data;
				{
					GHashFunc _tmp17_ = NULL;
					GEqualFunc _tmp18_ = NULL;
					GDestroyNotify _tmp19_ = NULL;
					GDestroyNotify _tmp20_ = NULL;
					GHashTable* _tmp21_ = NULL;
					JsonObject* services_object = NULL;
					JsonObject* _tmp22_ = NULL;
					const gchar* _tmp23_ = NULL;
					JsonNode* _tmp24_ = NULL;
					JsonObject* _tmp25_ = NULL;
					JsonObject* _tmp26_ = NULL;
					JsonObject* _tmp27_ = NULL;
					GList* _tmp28_ = NULL;
					GHashTable* _tmp54_ = NULL;
					const gchar* _tmp55_ = NULL;
					gchar* _tmp56_ = NULL;
					GHashTable* _tmp57_ = NULL;
					GHashTable* _tmp58_ = NULL;
					_tmp17_ = g_str_hash;
					_tmp18_ = g_str_equal;
					_tmp19_ = g_free;
					_tmp20_ = g_free;
					_tmp21_ = g_hash_table_new_full (_tmp17_, _tmp18_, _tmp19_, _tmp20_);
					_g_hash_table_unref0 (self->priv->service_table);
					self->priv->service_table = _tmp21_;
					_tmp22_ = root_object;
					_tmp23_ = service;
					_tmp24_ = json_object_get_member (_tmp22_, _tmp23_);
					_tmp25_ = json_node_get_object (_tmp24_);
					_tmp26_ = _json_object_ref0 (_tmp25_);
					services_object = _tmp26_;
					_tmp27_ = services_object;
					_tmp28_ = json_object_get_members (_tmp27_);
					{
						GList* member_collection = NULL;
						GList* member_it = NULL;
						member_collection = _tmp28_;
						for (member_it = member_collection; member_it != NULL; member_it = member_it->next) {
							const gchar* member = NULL;
							member = (const gchar*) member_it->data;
							{
								JsonObject* _tmp29_ = NULL;
								const gchar* _tmp30_ = NULL;
								JsonNode* _tmp31_ = NULL;
								const gchar* _tmp32_ = NULL;
								_tmp29_ = services_object;
								_tmp30_ = member;
								_tmp31_ = json_object_get_member (_tmp29_, _tmp30_);
								_tmp32_ = json_node_type_name (_tmp31_);
								if (g_strcmp0 (_tmp32_, "JsonArray") == 0) {
									JsonArray* service_array = NULL;
									JsonObject* _tmp33_ = NULL;
									const gchar* _tmp34_ = NULL;
									JsonArray* _tmp35_ = NULL;
									JsonArray* _tmp36_ = NULL;
									GList* service_attr_list = NULL;
									GHashTable* _tmp49_ = NULL;
									const gchar* _tmp50_ = NULL;
									gchar* _tmp51_ = NULL;
									GList* _tmp52_ = NULL;
									GList* _tmp53_ = NULL;
									_tmp33_ = services_object;
									_tmp34_ = member;
									_tmp35_ = json_object_get_array_member (_tmp33_, _tmp34_);
									_tmp36_ = _json_array_ref0 (_tmp35_);
									service_array = _tmp36_;
									service_attr_list = NULL;
									{
										gint i = 0;
										i = 0;
										{
											gboolean _tmp37_ = FALSE;
											_tmp37_ = TRUE;
											while (TRUE) {
												gint _tmp39_ = 0;
												JsonArray* _tmp40_ = NULL;
												guint _tmp41_ = 0U;
												gchar* f = NULL;
												JsonArray* _tmp42_ = NULL;
												gint _tmp43_ = 0;
												JsonNode* _tmp44_ = NULL;
												const gchar* _tmp45_ = NULL;
												gchar* _tmp46_ = NULL;
												const gchar* _tmp47_ = NULL;
												gchar* _tmp48_ = NULL;
												if (!_tmp37_) {
													gint _tmp38_ = 0;
													_tmp38_ = i;
													i = _tmp38_ + 1;
												}
												_tmp37_ = FALSE;
												_tmp39_ = i;
												_tmp40_ = service_array;
												_tmp41_ = json_array_get_length (_tmp40_);
												if (!(((guint) _tmp39_) < _tmp41_)) {
													break;
												}
												_tmp42_ = service_array;
												_tmp43_ = i;
												_tmp44_ = json_array_get_element (_tmp42_, (guint) _tmp43_);
												_tmp45_ = json_node_get_string (_tmp44_);
												_tmp46_ = g_strdup (_tmp45_);
												f = _tmp46_;
												_tmp47_ = f;
												_tmp48_ = g_strdup (_tmp47_);
												service_attr_list = g_list_append (service_attr_list, _tmp48_);
												_g_free0 (f);
											}
										}
									}
									_tmp49_ = self->priv->service_table;
									_tmp50_ = member;
									_tmp51_ = g_strdup (_tmp50_);
									_tmp52_ = service_attr_list;
									_tmp53_ = g_list_copy (_tmp52_);
									g_hash_table_insert (_tmp49_, _tmp51_, _tmp53_);
									__g_list_free__g_free0_0 (service_attr_list);
									_json_array_unref0 (service_array);
									continue;
								}
							}
						}
						_g_list_free0 (member_collection);
					}
					_tmp54_ = self->priv->services_table;
					_tmp55_ = service;
					_tmp56_ = g_strdup (_tmp55_);
					_tmp57_ = self->priv->service_table;
					_tmp58_ = _g_hash_table_ref0 (_tmp57_);
					g_hash_table_insert (_tmp54_, _tmp56_, _tmp58_);
					_json_object_unref0 (services_object);
				}
			}
			_g_list_free0 (service_collection);
		}
		_tmp59_ = self->priv->services_table;
		_tmp60_ = _g_hash_table_ref0 (_tmp59_);
		result = _tmp60_;
		_json_object_unref0 (root_object);
		_g_object_unref0 (parser);
		_g_free0 (services);
		return result;
	}
	goto __finally23;
	__catch23_g_error:
	{
		GError* e = NULL;
		GError* _tmp61_ = NULL;
		const gchar* _tmp62_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp61_ = e;
		_tmp62_ = _tmp61_->message;
		g_warning ("service.vala:405: %s", _tmp62_);
		result = NULL;
		_g_error_free0 (e);
		return result;
	}
	__finally23:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return NULL;
}


static void _vala_GValue_free (GValue* self) {
	g_value_unset (self);
	g_free (self);
}


static GValue* _g_value_dup (GValue* self) {
	return g_boxed_copy (G_TYPE_VALUE, self);
}


static gpointer __g_value_dup0 (gpointer self) {
	return self ? _g_value_dup (self) : NULL;
}


GHashTable* gwibber_service_features (GwibberService* self) {
	GHashTable* result = NULL;
	GHashFunc _tmp0_ = NULL;
	GEqualFunc _tmp1_ = NULL;
	GDestroyNotify _tmp2_ = NULL;
	GHashTable* _tmp3_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_str_hash;
	_tmp1_ = g_str_equal;
	_tmp2_ = g_free;
	_tmp3_ = g_hash_table_new_full (_tmp0_, _tmp1_, _tmp2_, _g_hash_table_remove_all_gdestroy_notify);
	_g_hash_table_unref0 (self->priv->features_table);
	self->priv->features_table = _tmp3_;
	{
		gchar* features = NULL;
		ServiceInterface* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		JsonParser* parser = NULL;
		JsonParser* _tmp6_ = NULL;
		JsonObject* root_object = NULL;
		JsonParser* _tmp11_ = NULL;
		JsonNode* _tmp12_ = NULL;
		JsonObject* _tmp13_ = NULL;
		JsonObject* _tmp14_ = NULL;
		JsonObject* _tmp15_ = NULL;
		GList* _tmp16_ = NULL;
		GHashTable* _tmp58_ = NULL;
		GHashTable* _tmp59_ = NULL;
		_tmp4_ = self->priv->service;
		_tmp5_ = service_interface_GetFeatures (_tmp4_, &_inner_error_);
		features = _tmp5_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch25_g_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp6_ = json_parser_new ();
		parser = _tmp6_;
		{
			JsonParser* _tmp7_ = NULL;
			const gchar* _tmp8_ = NULL;
			_tmp7_ = parser;
			_tmp8_ = features;
			json_parser_load_from_data (_tmp7_, _tmp8_, (gssize) (-1), &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch26_g_error;
			}
		}
		goto __finally26;
		__catch26_g_error:
		{
			GError* e = NULL;
			GError* _tmp9_ = NULL;
			const gchar* _tmp10_ = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp9_ = e;
			_tmp10_ = _tmp9_->message;
			g_warning ("service.vala:419: %s", _tmp10_);
			result = NULL;
			_g_error_free0 (e);
			_g_object_unref0 (parser);
			_g_free0 (features);
			return result;
		}
		__finally26:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (parser);
			_g_free0 (features);
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch25_g_io_error;
			}
			_g_object_unref0 (parser);
			_g_free0 (features);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp11_ = parser;
		_tmp12_ = json_parser_get_root (_tmp11_);
		_tmp13_ = json_node_get_object (_tmp12_);
		_tmp14_ = _json_object_ref0 (_tmp13_);
		root_object = _tmp14_;
		_tmp15_ = root_object;
		_tmp16_ = json_object_get_members (_tmp15_);
		{
			GList* feature_collection = NULL;
			GList* feature_it = NULL;
			feature_collection = _tmp16_;
			for (feature_it = feature_collection; feature_it != NULL; feature_it = feature_it->next) {
				const gchar* feature = NULL;
				feature = (const gchar*) feature_it->data;
				{
					GHashFunc _tmp17_ = NULL;
					GEqualFunc _tmp18_ = NULL;
					GDestroyNotify _tmp19_ = NULL;
					GDestroyNotify _tmp20_ = NULL;
					GHashTable* _tmp21_ = NULL;
					JsonObject* features_object = NULL;
					JsonObject* _tmp22_ = NULL;
					const gchar* _tmp23_ = NULL;
					JsonNode* _tmp24_ = NULL;
					JsonObject* _tmp25_ = NULL;
					JsonObject* _tmp26_ = NULL;
					JsonObject* _tmp27_ = NULL;
					GList* _tmp28_ = NULL;
					GHashTable* _tmp53_ = NULL;
					const gchar* _tmp54_ = NULL;
					gchar* _tmp55_ = NULL;
					GHashTable* _tmp56_ = NULL;
					GHashTable* _tmp57_ = NULL;
					_tmp17_ = g_str_hash;
					_tmp18_ = g_str_equal;
					_tmp19_ = g_free;
					_tmp20_ = g_free;
					_tmp21_ = g_hash_table_new_full (_tmp17_, _tmp18_, _tmp19_, _tmp20_);
					_g_hash_table_unref0 (self->priv->feature_table);
					self->priv->feature_table = _tmp21_;
					_tmp22_ = root_object;
					_tmp23_ = feature;
					_tmp24_ = json_object_get_member (_tmp22_, _tmp23_);
					_tmp25_ = json_node_get_object (_tmp24_);
					_tmp26_ = _json_object_ref0 (_tmp25_);
					features_object = _tmp26_;
					_tmp27_ = features_object;
					_tmp28_ = json_object_get_members (_tmp27_);
					{
						GList* member_collection = NULL;
						GList* member_it = NULL;
						member_collection = _tmp28_;
						for (member_it = member_collection; member_it != NULL; member_it = member_it->next) {
							const gchar* member = NULL;
							member = (const gchar*) member_it->data;
							{
								GValue* value = NULL;
								JsonObject* _tmp29_ = NULL;
								const gchar* _tmp30_ = NULL;
								JsonNode* _tmp31_ = NULL;
								gboolean _tmp32_ = FALSE;
								GHashTable* _tmp48_ = NULL;
								const gchar* _tmp49_ = NULL;
								gchar* _tmp50_ = NULL;
								GValue* _tmp51_ = NULL;
								GValue* _tmp52_ = NULL;
								value = NULL;
								_tmp29_ = features_object;
								_tmp30_ = member;
								_tmp31_ = json_object_get_member (_tmp29_, _tmp30_);
								_tmp32_ = json_node_is_null (_tmp31_);
								if (_tmp32_) {
									__vala_GValue_free0 (value);
									continue;
								} else {
									JsonObject* _tmp33_ = NULL;
									const gchar* _tmp34_ = NULL;
									JsonNode* _tmp35_ = NULL;
									const gchar* _tmp36_ = NULL;
									_tmp33_ = features_object;
									_tmp34_ = member;
									_tmp35_ = json_object_get_member (_tmp33_, _tmp34_);
									_tmp36_ = json_node_type_name (_tmp35_);
									if (g_strcmp0 (_tmp36_, "gboolean") == 0) {
										JsonObject* _tmp37_ = NULL;
										const gchar* _tmp38_ = NULL;
										JsonNode* _tmp39_ = NULL;
										gboolean _tmp40_ = FALSE;
										GValue* _tmp41_ = NULL;
										_tmp37_ = features_object;
										_tmp38_ = member;
										_tmp39_ = json_object_get_member (_tmp37_, _tmp38_);
										_tmp40_ = json_node_get_boolean (_tmp39_);
										_tmp41_ = g_new0 (GValue, 1);
										g_value_init (_tmp41_, G_TYPE_BOOLEAN);
										g_value_set_boolean (_tmp41_, _tmp40_);
										__vala_GValue_free0 (value);
										value = _tmp41_;
									} else {
										JsonObject* _tmp42_ = NULL;
										const gchar* _tmp43_ = NULL;
										JsonNode* _tmp44_ = NULL;
										GValue _tmp45_ = {0};
										GValue _tmp46_ = {0};
										GValue* _tmp47_ = NULL;
										_tmp42_ = features_object;
										_tmp43_ = member;
										_tmp44_ = json_object_get_member (_tmp42_, _tmp43_);
										json_node_get_value (_tmp44_, &_tmp45_);
										_tmp46_ = _tmp45_;
										_tmp47_ = __g_value_dup0 (&_tmp46_);
										__vala_GValue_free0 (value);
										value = _tmp47_;
										G_IS_VALUE (&_tmp46_) ? (g_value_unset (&_tmp46_), NULL) : NULL;
									}
								}
								_tmp48_ = self->priv->feature_table;
								_tmp49_ = member;
								_tmp50_ = g_strdup (_tmp49_);
								_tmp51_ = value;
								_tmp52_ = __g_value_dup0 (_tmp51_);
								g_hash_table_insert (_tmp48_, _tmp50_, _tmp52_);
								__vala_GValue_free0 (value);
							}
						}
						_g_list_free0 (member_collection);
					}
					_tmp53_ = self->priv->features_table;
					_tmp54_ = feature;
					_tmp55_ = g_strdup (_tmp54_);
					_tmp56_ = self->priv->feature_table;
					_tmp57_ = _g_hash_table_ref0 (_tmp56_);
					g_hash_table_insert (_tmp53_, _tmp55_, _tmp57_);
					_json_object_unref0 (features_object);
				}
			}
			_g_list_free0 (feature_collection);
		}
		_tmp58_ = self->priv->features_table;
		_tmp59_ = _g_hash_table_ref0 (_tmp58_);
		result = _tmp59_;
		_json_object_unref0 (root_object);
		_g_object_unref0 (parser);
		_g_free0 (features);
		return result;
	}
	goto __finally25;
	__catch25_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp60_ = NULL;
		const gchar* _tmp61_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp60_ = e;
		_tmp61_ = _tmp60_->message;
		g_warning ("service.vala:441: %s", _tmp61_);
		result = NULL;
		_g_error_free0 (e);
		return result;
	}
	__finally25:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return NULL;
}


/**
            version:

            Return value: the version of the Gwibber service that is running.
        */
gchar* gwibber_service_version (GwibberService* self) {
	gchar* result = NULL;
	gchar* _tmp6_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	{
		gchar* _tmp0_ = NULL;
		ServiceInterface* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		_tmp1_ = self->priv->service;
		_tmp2_ = service_interface_GetVersion (_tmp1_, &_inner_error_);
		_tmp0_ = _tmp2_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch27_g_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp3_ = _tmp0_;
		_tmp0_ = NULL;
		result = _tmp3_;
		_g_free0 (_tmp0_);
		return result;
	}
	goto __finally27;
	__catch27_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		g_warning ("service.vala:457: %s", _tmp5_);
		_g_error_free0 (e);
	}
	__finally27:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp6_ = g_strdup ("");
	result = _tmp6_;
	return result;
}


/**
            avatar_path:
            @url: url to the avatar to cache

            Return value: path to the cached avatar as a string
        */
gchar* gwibber_service_avatar_path (GwibberService* self, const gchar* url, GError** error) {
	gchar* result = NULL;
	gchar* _avatar_cache_image = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	GFile* file = NULL;
	const gchar* _tmp6_ = NULL;
	GFile* _tmp7_ = NULL;
	GFile* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (url != NULL, NULL);
	_tmp0_ = g_get_user_cache_dir ();
	_tmp1_ = url;
	_tmp2_ = g_compute_checksum_for_string (G_CHECKSUM_SHA1, _tmp1_, (gsize) (-1));
	_tmp3_ = _tmp2_;
	_tmp4_ = g_build_path (G_DIR_SEPARATOR_S, _tmp0_, "gwibber/avatars", _tmp3_, NULL);
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp3_);
	_avatar_cache_image = _tmp5_;
	_tmp6_ = _avatar_cache_image;
	_tmp7_ = g_file_new_for_path (_tmp6_);
	file = _tmp7_;
	_tmp8_ = file;
	_tmp9_ = g_file_query_exists (_tmp8_, NULL);
	if (_tmp9_) {
		result = _avatar_cache_image;
		_g_object_unref0 (file);
		return result;
	} else {
		gchar* _tmp10_ = NULL;
		ServiceInterface* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		_tmp11_ = self->priv->service;
		_tmp12_ = url;
		_tmp13_ = service_interface_GetAvatarPath (_tmp11_, _tmp12_, &_inner_error_);
		_tmp10_ = _tmp13_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (file);
			_g_free0 (_avatar_cache_image);
			return NULL;
		}
		_tmp14_ = _tmp10_;
		_tmp10_ = NULL;
		_g_free0 (_avatar_cache_image);
		_avatar_cache_image = _tmp14_;
		_g_free0 (_tmp10_);
	}
	result = _avatar_cache_image;
	_g_object_unref0 (file);
	return result;
}


void gwibber_service_perform (GwibberService* self, const gchar* id, GError** error) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (id != NULL);
	{
		ServiceInterface* _tmp0_ = NULL;
		const gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		_tmp0_ = self->priv->service;
		_tmp1_ = id;
		_tmp2_ = g_strconcat ("{\"id\": \"", _tmp1_, NULL);
		_tmp3_ = _tmp2_;
		_tmp4_ = g_strconcat (_tmp3_, "\"}", NULL);
		_tmp5_ = _tmp4_;
		service_interface_PerformOp (_tmp0_, _tmp5_, &_inner_error_);
		_g_free0 (_tmp5_);
		_g_free0 (_tmp3_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch28_g_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	goto __finally28;
	__catch28_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp6_ = e;
		_tmp7_ = _tmp6_->message;
		g_warning ("service.vala:484: %s", _tmp7_);
		_g_error_free0 (e);
	}
	__finally28:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return;
	}
}


void gwibber_service_follow (GwibberService* self, const gchar* account, const gchar* screen_name, gboolean follow, GError** error) {
	gchar* action = NULL;
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (account != NULL);
	g_return_if_fail (screen_name != NULL);
	_tmp0_ = g_strdup ("unfollow");
	action = _tmp0_;
	_tmp1_ = follow;
	if (_tmp1_) {
		gchar* _tmp2_ = NULL;
		_tmp2_ = g_strdup ("follow");
		_g_free0 (action);
		action = _tmp2_;
	}
	{
		ServiceInterface* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		gchar* _tmp11_ = NULL;
		gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		const gchar* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_ = NULL;
		gchar* _tmp18_ = NULL;
		_tmp3_ = self->priv->service;
		_tmp4_ = account;
		_tmp5_ = g_strconcat ("{\"account\": \"", _tmp4_, NULL);
		_tmp6_ = _tmp5_;
		_tmp7_ = g_strconcat (_tmp6_, "\", \"operation\": \"", NULL);
		_tmp8_ = _tmp7_;
		_tmp9_ = action;
		_tmp10_ = g_strconcat (_tmp8_, _tmp9_, NULL);
		_tmp11_ = _tmp10_;
		_tmp12_ = g_strconcat (_tmp11_, "\", \"args\": {\"screen_name\": \"", NULL);
		_tmp13_ = _tmp12_;
		_tmp14_ = screen_name;
		_tmp15_ = g_strconcat (_tmp13_, _tmp14_, NULL);
		_tmp16_ = _tmp15_;
		_tmp17_ = g_strconcat (_tmp16_, "\"}}", NULL);
		_tmp18_ = _tmp17_;
		service_interface_PerformOp (_tmp3_, _tmp18_, &_inner_error_);
		_g_free0 (_tmp18_);
		_g_free0 (_tmp16_);
		_g_free0 (_tmp13_);
		_g_free0 (_tmp11_);
		_g_free0 (_tmp8_);
		_g_free0 (_tmp6_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch29_g_io_error;
			}
			_g_free0 (action);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	goto __finally29;
	__catch29_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp19_ = NULL;
		const gchar* _tmp20_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp19_ = e;
		_tmp20_ = _tmp19_->message;
		g_warning ("service.vala:498: %s", _tmp20_);
		_g_error_free0 (e);
	}
	__finally29:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_free0 (action);
		return;
	}
	_g_free0 (action);
}


void gwibber_service_update_indicators (GwibberService* self, const gchar* stream) {
	const gchar* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = stream;
	if (_tmp0_ == NULL) {
		stream = "home";
	}
	{
		ServiceInterface* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		_tmp1_ = self->priv->service;
		_tmp2_ = stream;
		service_interface_UpdateIndicators (_tmp1_, _tmp2_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch30_g_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	goto __finally30;
	__catch30_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_warning ("service.vala:509: %s", _tmp4_);
		_g_error_free0 (e);
	}
	__finally30:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


GwibberService* gwibber_service_construct (GType object_type) {
	GwibberService * self = NULL;
	self = (GwibberService*) g_object_new (object_type, NULL);
	return self;
}


GwibberService* gwibber_service_new (void) {
	return gwibber_service_construct (GWIBBER_TYPE_SERVICE);
}


static void g_cclosure_user_marshal_VOID__STRING_STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_STRING_STRING) (gpointer data1, const char* arg_1, const char* arg_2, const char* arg_3, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_STRING_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), g_value_get_string (param_values + 3), data2);
}


static void _gwibber_service_service_available_gwibber_utils_available (GwibberUtils* _sender, gboolean up, gpointer self) {
	gwibber_service_service_available ((GwibberService*) self, up);
}


static void _gwibber_service_on_loading_started_service_interface_loading_started (ServiceInterface* _sender, gpointer self) {
	gwibber_service_on_loading_started ((GwibberService*) self);
}


static void _gwibber_service_on_loading_complete_service_interface_loading_complete (ServiceInterface* _sender, gpointer self) {
	gwibber_service_on_loading_complete ((GwibberService*) self);
}


static void _gwibber_service____lambda8_ (GwibberService* self, const gchar* source) {
	const gchar* _tmp0_ = NULL;
	g_return_if_fail (source != NULL);
	_tmp0_ = source;
	gwibber_service_on_error (self, _tmp0_);
}


static void __gwibber_service____lambda8__service_interface_error (ServiceInterface* _sender, const gchar* error_str, gpointer self) {
	_gwibber_service____lambda8_ ((GwibberService*) self, error_str);
}


static GObject * gwibber_service_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	GwibberService * self;
	GwibberMessages* _tmp13_ = NULL;
	GError * _inner_error_ = NULL;
	parent_class = G_OBJECT_CLASS (gwibber_service_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GWIBBER_TYPE_SERVICE, GwibberService);
	{
		ServiceInterface* _tmp0_ = NULL;
		ServiceInterface* _tmp1_ = NULL;
		ServiceInterface* _tmp2_ = NULL;
		GwibberUtils* _tmp3_ = NULL;
		GwibberUtils* _tmp4_ = NULL;
		GwibberUtils* _tmp5_ = NULL;
		ServiceInterface* _tmp6_ = NULL;
		ServiceInterface* _tmp7_ = NULL;
		ServiceInterface* _tmp8_ = NULL;
		_tmp1_ = g_initable_new (TYPE_SERVICE_INTERFACE_PROXY, NULL, &_inner_error_, "g-flags", 0, "g-name", GWIBBER_SERVICE_service_name, "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", GWIBBER_SERVICE_service_path, "g-interface-name", "com.Gwibber.Service", NULL);
		_tmp0_ = (ServiceInterface*) _tmp1_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch31_g_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (self->priv->service);
		self->priv->service = _tmp2_;
		_tmp3_ = gwibber_utils_new ();
		_g_object_unref0 (self->priv->utils);
		self->priv->utils = _tmp3_;
		_tmp4_ = self->priv->utils;
		gwibber_utils_setup (_tmp4_, GWIBBER_SERVICE_service_name, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (_tmp0_);
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch31_g_io_error;
			}
			_g_object_unref0 (_tmp0_);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
		}
		_tmp5_ = self->priv->utils;
		g_signal_connect_object (_tmp5_, "available", (GCallback) _gwibber_service_service_available_gwibber_utils_available, self, 0);
		_tmp6_ = self->priv->service;
		g_signal_connect_object (_tmp6_, "loading-started", (GCallback) _gwibber_service_on_loading_started_service_interface_loading_started, self, 0);
		_tmp7_ = self->priv->service;
		g_signal_connect_object (_tmp7_, "loading-complete", (GCallback) _gwibber_service_on_loading_complete_service_interface_loading_complete, self, 0);
		_tmp8_ = self->priv->service;
		g_signal_connect_object (_tmp8_, "error", (GCallback) __gwibber_service____lambda8__service_interface_error, self, 0);
		_g_object_unref0 (_tmp0_);
	}
	goto __finally31;
	__catch31_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		gchar* _tmp11_ = NULL;
		gchar* _tmp12_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp9_ = e;
		_tmp10_ = _tmp9_->message;
		_tmp11_ = g_strconcat ("Unable to get Gwibber service: ", _tmp10_, NULL);
		_tmp12_ = _tmp11_;
		g_warning ("service.vala:111: %s", _tmp12_);
		_g_free0 (_tmp12_);
		_g_error_free0 (e);
	}
	__finally31:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
	}
	_tmp13_ = gwibber_messages_new ();
	_g_object_unref0 (self->priv->messages);
	self->priv->messages = _tmp13_;
	return obj;
}


static void gwibber_service_class_init (GwibberServiceClass * klass) {
	gwibber_service_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GwibberServicePrivate));
	G_OBJECT_CLASS (klass)->constructor = gwibber_service_constructor;
	G_OBJECT_CLASS (klass)->finalize = gwibber_service_finalize;
	/** 
	            Service::is_available:
	            @arg0: The current state
	
	            Emitted when com.Gwibber.Service availability state changes
	        */
	g_signal_new ("is_available", GWIBBER_TYPE_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	/**
	            Service::loading_started:
	
	            Emitted when an operations starts
	        */
	g_signal_new ("loading_started", GWIBBER_TYPE_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	/**
	            Service::loading_started:
	
	            Emitted when an operations is complete
	        */
	g_signal_new ("loading_complete", GWIBBER_TYPE_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	/**
	            Service::error:
	            @arg0: String containing the account id
	            @arg1: String containing the error type
	            @arg2: String containing the error message
	
	            Emitted when an error is received from the service
	        */
	g_signal_new ("error", GWIBBER_TYPE_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING_STRING, G_TYPE_NONE, 3, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING);
}


static void gwibber_service_instance_init (GwibberService * self) {
	self->priv = GWIBBER_SERVICE_GET_PRIVATE (self);
}


static void gwibber_service_finalize (GObject* obj) {
	GwibberService * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GWIBBER_TYPE_SERVICE, GwibberService);
	_g_object_unref0 (self->priv->service);
	_g_hash_table_unref0 (self->priv->services_table);
	_g_hash_table_unref0 (self->priv->service_table);
	_g_hash_table_unref0 (self->priv->features_table);
	_g_hash_table_unref0 (self->priv->feature_table);
	_g_object_unref0 (self->priv->utils);
	_g_object_unref0 (self->priv->messages);
	G_OBJECT_CLASS (gwibber_service_parent_class)->finalize (obj);
}


GType gwibber_service_get_type (void) {
	static volatile gsize gwibber_service_type_id__volatile = 0;
	if (g_once_init_enter (&gwibber_service_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GwibberServiceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gwibber_service_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GwibberService), 0, (GInstanceInitFunc) gwibber_service_instance_init, NULL };
		GType gwibber_service_type_id;
		gwibber_service_type_id = g_type_register_static (G_TYPE_OBJECT, "GwibberService", &g_define_type_info, 0);
		g_once_init_leave (&gwibber_service_type_id__volatile, gwibber_service_type_id);
	}
	return gwibber_service_type_id__volatile;
}



